dnl --------- otop.m4, generic prelude file for the OTOP subproject ----------
dnl
dnl
divert(-1)


--- Things to do *BEFORE* to include macro.m4


* Firstly, have BEGIN/END expanded by CPP,
 so we won't get mixed up
 with our having m4 quote with {curly braces}

* See that this is done in the __C_CPP__ diversion, defined below
 as this should be done after C include files are included

divert(2)
#define BEGIN	{
#define END	}
#define OPEN_BRACE_CHAR '{'
#define CLOSE_BRACE_CHAR '}'
#define OPEN_BRACE_STR "{"
#define CLOSE_BRACE_STR "}"
divert(-1)


--- *Now* we can include macro.m4

include(macro.m4)
divert(-1)
changecom(/*,*/)dnl


--- Let's declare diversions/segments


define({___BEGIN___})

declarediversion({__C_HEADER__})  pure/standard C/CPP include files and macros
declarediversion({__C_CPP__})	  CPP macro definitions that'd interfere with m4
declarediversion({__C_DECLS__})	  type definitions, function/data declarations,
declarediversion({__C_CODE__})	  C code for the OTOP runtime system
declarediversion({__HEADER__})	  pseudo-asm header
declarediversion({__DATA__})	  pseudo-asm data
declarediversion({__PCODE__})	  interpreted pseudo-code
declarerevidsion({__DATAFOOT__})  pseudo-asm data
declarediversion({__INIT__})	  pseudo-asm initialization code
declarerevidsion({__INITFOOT__})  pseudo-asm initialization code footer
declarediversion({__CODE__})	  pseudo-asm code
dnl declarediversion({__GC__})	  pseudo-asm garbage collection code
dnl declarediversion({__SYNC__})  pseudo-asm synchronization code
declarerevidsion({__ENDCODE__})	  pseudo-asm end of all code segments
declarediversion({__EXITHEAD__})  pseudo-asm clean shutdown code header
declarerevidsion({__EXIT__})	  pseudo-asm clean shutdown code
declarerevidsion({__FOOTER__})	  pseudo-asm footer
declarerevidsion({__C_FOOTER__})  C footer

define({___END___},
{
flush_revidsions
dnl divert
dnl undivert
})

dnl {}divert{}undivert})

--- Include all OTOP definition files.

Provide({otop},{

Require({version})
Require({magic})
Require(indir($$CONFIG))
Require({debug})
Require({ansic})
Require({endian})
Require({threading})

})dnl --- End of otop.m4 ---

divert(-1)dnl
